import unittest
from unittest.mock import patch

from tmc import points
from tmc.utils import load, load_module, reload_module, get_stdout, check_source
from functools import reduce
import os
import textwrap

exercise = 'src.sum_of_lists'
function = 'list_sum'

def get_correct(l1: list, l2: list) -> list:
    return [x + y for x,y in zip(l1,l2)]

@points('1.sum_of_lists')
class SumOfListsTest(unittest.TestCase):
    @classmethod
    def setUpClass(cls):
        with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
           cls.module = load_module(exercise, 'en')

    def test_0_main_program_ok(self):
        ok, line = check_source(self.module)
        message = """Koden för att testa funktionerna ska placeras inuti
if __name__ == "__main__":
block. Följande rad ska flyttas:
"""
        self.assertTrue(ok, message+line)

    def test_1_function_exists(self):
        try:
            from src.sum_of_lists import list_sum
        except:
            self.assertTrue(False, 'Din kod bör innehålla en funktion som heter list_sum(list1: list, list2: list)')
        try:
            list_sum = load(exercise, function, 'en')
            list_sum([1],[1])
        except:
            self.assertTrue(False, 'Testa funktionsanrop\nlist_sum([1],[1])')


    def test_2_type_of_return_value(self):
        list_sum = load(exercise, function, 'en')
        val = list_sum([1],[2])
        self.assertTrue(type(val) == list, f"Att ringa {function} returnerar ingen lista när man anropar list_sum([1],[2])")

    def test_3_numbers_1(self):
        test_cases = [([1,2,3], [1,2,3]), ([2,4,6], [3,5,7]), ([1,2,1,2,1,2],[2,3,4,5,6,7])]
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                list_sum = load(exercise, function, 'en')

                correct = get_correct(test_case[0], test_case[1])
                test_case2 = test_case[:]
                test_result = list_sum(test_case[0], test_case[1])

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när list_sum({test_case2}) anropas")
                self.assertEqual(test_case, test_case2, f"Funktionen bör inte ändra den ursprungliga listan. Listan ska vara {list(test_case2)} men den är {list(test_case)}.")

    def test_4_numbers_2(self):
        test_cases = [([10,10,10,11], [99,999,9,99]), ([-10,-11,-12], [1,2,3]), ([100,101,102,103,104],[99,98,97,96,95])]
        for test_case in test_cases:
            with patch('builtins.input', side_effect=[AssertionError("Att be om input från användaren förväntades inte")]):
                reload_module(self.module)
                output_at_start = get_stdout()
                list_sum = load(exercise, function, 'en')

                correct = get_correct(test_case[0], test_case[1])
                test_case2 = test_case[:]
                test_result = list_sum(test_case[0], test_case[1])

                self.assertEqual(correct, test_result, f"Resultatet {test_result} matchar inte det förväntade resultatet {correct} när list_sum({test_case2}) anropas")
                self.assertEqual(test_case, test_case2, f"Funktionen bör inte ändra den ursprungliga listan. Listan ska vara {list(test_case2)} men den är {list(test_case)}.")

if __name__ == '__main__':
    unittest.main()
